import csv

fname = '/var/log/custom_process_ppk.exectime'
fnamePPK = '/var/log/standard_process_ppk.exectime'
rows = []
server = True
standardPPK = True

def main():
    if (standardPPK):

        # Parse log file obtained from standardWorker.py

        if (server):
            csvName = '/var/log/standard_process_ppk_server.csv'
        else:
            csvName = '/var/log/standard_process_ppk_client.csv'

        with open(csvName, "w") as csvFp:
            csvWriter = csv.writer(csvFp, delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)
            csvWriter.writerow(['Iteration', 'Total time', ''])
            csvWriter.writerow(['', 'w_time', 'cpu_time'])

            with open(fnamePPK) as fp:
                iteration = 0
                times = []
                for i, line in enumerate(fp):
                    if(line == '\n'):
                        continue

                    if ('Execution' in line):
                        line = line.replace(" ", "")

                        startLine, _, line = line.partition('[WALL]')
                        w_time, _, line = line.partition('seconds')
                        times.append(float(w_time))
                        
                        _, _, line = line.partition('[CPU]')
                        cpu_time, _, _ = line.partition('seconds')
                        times.append(float(cpu_time))

                        iteration += 1
                        times.insert(0, iteration)
                        csvWriter.writerow(times)
                        times.clear()
        
    else:

        # Parse log file obtained from worker.py

        if (server):
            csvName = '/var/log/custom_process_ppk_server.csv'
            with open(csvName, "w") as csvFp:
                csvWriter = csv.writer(csvFp, delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)
                csvWriter.writerow(['Iteration', 'Configuration read and load', '', 'Socket bound, wait conn', '',  'Read handle', '', 'GET_TOKEN', '', 'Parse token', '', 'GET_KEY_WITH_ID', '', 'Parse key', '', 'Stored PPK and PPK_ID', '', 'Total time',])
                csvWriter.writerow(['', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time'])

                with open(fname) as fp:
                    iteration = 0
                    times = []
                    for i, line in enumerate(fp):
                        if(line == '\n'):
                            continue
                        line = line.replace(" ", "")

                        startLine, _, line = line.partition('[WALL]')
                        w_time, _, line = line.partition('seconds')
                        times.append(float(w_time))
                        
                        _, _, line = line.partition('[CPU]')
                        cpu_time, _, _ = line.partition('seconds')
                        times.append(float(cpu_time))

                        if ('Execution' in startLine):
                            iteration += 1
                            times.insert(0, iteration)
                            csvWriter.writerow(times)
                            times.clear()

        else:
            csvName = '/var/log/custom_process_ppk_client.csv' 
            with open(csvName, "w") as csvFp:
                csvWriter = csv.writer(csvFp, delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)
                csvWriter.writerow(['Iteration', 'Configuration read and load', '', 'GET_TOKEN', '', 'Parse token', '', 'GET_KEY', '', 'Parse key', '', 'Created socket, start connection', '', 'Send handle to server', '', 'Received ACK from Server', '', 'Store PPK and PPK_ID', '', 'Total time', ''])
                csvWriter.writerow(['', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time'])

                with open(fname) as fp:
                    iteration = 0
                    times = []
                    for i, line in enumerate(fp):
                        if(line == '\n'):
                            continue
                        line = line.replace(" ", "")

                        startLine, _, line = line.partition('[WALL]')
                        w_time, _, line = line.partition('seconds')
                        times.append(float(w_time))
                        
                        _, _, line = line.partition('[CPU]')
                        cpu_time, _, _ = line.partition('seconds')
                        times.append(float(cpu_time))

                        if ('Execution' in startLine):
                            iteration += 1
                            times.insert(0, iteration)
                            csvWriter.writerow(times)
                            times.clear()
                            
                    

            


if __name__ == '__main__':
    main()
