from os import path

# Class representing text file containing id-psk pairs
class ManageSecrets:
    
    # If file already exists it will load pairs, else it will create the file
    def __init__(self, filePath):
        self.fp = filePath
        self.pairs = {}
        if (path.isfile(filePath)):
            file = open(filePath, "r")
            for line in file:
                if (line != '\n' and line != '\r\n'):
                    key, psk = line.split(":")
                    self.pairs[key] = psk
            file.close()
        else:
            file = open(filePath, "w+")
            file.close()

    # This function will check if it is already present a line containing id and psk received:
    # - if such a line does exist, then no action is taken
    # - if id is present but psk is different, then psk is updated
    # - if it doesn't exist, then it is appended
    def addLine(self, id, psk):

        if (id in self.pairs.keys()):
            # id already present
            if (psk == self.pairs[id]):
                # line already exists
                print("Line already existent!")
                return 1
            else:
                # psk must be updated
                self.pairs[id] = psk
                # i'm updating in a silly way, should be improved
                file = open(self.fp, "w+")
                for key in self.pairs.keys():
                    file.write(f"{key}:{self.pairs[key]}")

        else:
            #id not present
            self.pairs[id] = psk
            file = open(self.fp, "a+")
            file.write(f"\n{id}:{psk}")
        file.close()
        return 0


    # for debug purpose, it writes only last key retrieved
    def addOnlyLast(self, id, psk):
        self.pairs[id] = psk
        file = open(self.fp, "w")
        file.write(f"{id}:{psk}")
        file.close()
        return 0


