import csv

fname = 'setupStunn.log'
fnamePSK = 'setupStunnPSK.log'
rows = []
server = False
standardPSK = True

def main():
    if (standardPSK):

        # Parse log file obtained from standardWorker.py

        csvName = 'stunnel-standard-psk.csv'
        with open(csvName, "w") as csvFp:
            csvWriter = csv.writer(csvFp, delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)
            csvWriter.writerow(['Iteration', 'Load Config file', 'Create/Load secrets file', 'Key parsed and stored', 'Stunnel started/reconfigured', 'Total time'])

            with open(fnamePSK) as fp:
                iteration = 0
                times = []
                for i, line in enumerate(fp):
                    if(line == '\n'):
                        continue
                    line = line.replace(" ", "")
                    line, _, time = line.partition('time:')
                    time, _, _ = time.partition('seconds')
                    times.append(float(time))
                    _, _, line = line.partition(']')

                    if (line.startswith('Total')):
                        iteration += 1
                        times.insert(0, iteration)
                        csvWriter.writerow(times)
                        times.clear()
        
    else:

        # Parse log file obtained from worker.py

        if (server):
            csvName = 'stunnel-ks-server.csv'
            with open(csvName, "w") as csvFp:
                csvWriter = csv.writer(csvFp, delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)
                csvWriter.writerow(['Iteration', 'Load Config file', 'Create/Load secrets file', 'Retrieved token', 'Listen socket bound', 'Retrieved Handle from client', 'GET_KEY_WITH_ID', 'Key parsed and stored', 'Stunnel started/reconfigured', 'Send ACK to client', 'Total time'])

                with open(fname) as fp:
                    iteration = 0
                    times = []
                    for i, line in enumerate(fp):
                        if(line == '\n'):
                            continue
                        line = line.replace(" ", "")
                        line, _, time = line.partition('time:')
                        time, _, _ = time.partition('seconds')
                        times.append(float(time))
                        _, _, line = line.partition(']')

                        if (line.startswith('Total')):
                            iteration += 1
                            times.insert(0, iteration)
                            csvWriter.writerow(times)
                            times.clear()

        else:
            csvName = 'stunnel-ks-client.csv' 
            with open(csvName, "w") as csvFp:
                csvWriter = csv.writer(csvFp, delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)
                csvWriter.writerow(['Iteration', 'Load Config file', 'Create/Load secrets file', 'Retrieved token', 'GET KEY', 'Key parsed and stored', 'Handle sent to server', 'Received ACK', 'Stunnel started/reconfigured', 'Total time'])

                with open(fname) as fp:
                    iteration = 0
                    times = []
                    for i, line in enumerate(fp):
                        if(line == '\n'):
                            continue
                        line = line.replace(" ", "")
                        line, _, time = line.partition('time:')
                        time, _, _ = time.partition('seconds')
                        times.append(float(time))
                        _, _, line = line.partition(']')

                        if (line.startswith('Total')):
                            iteration += 1
                            times.insert(0, iteration)
                            csvWriter.writerow(times)
                            times.clear()
                            
                    

            


if __name__ == '__main__':
    main()
