import socket
import subprocess
import time
from threading import Thread

sender = False
standardPSK = True
staticKeyID = "43464eb8-15ea-44d6-9bf5-787eeee8abae-24"
staticKey = "yus9e1lDaj6SgzXm80/7Ow=="

host = "192.168.0.237"
port = 12012

target_host = "192.168.0.247"

N_TEST = 100

# thread function to execute worker.py
def startKSworker():
    execWorker = subprocess.Popen(["python3", "worker.py"])
    execWorker.wait()

# thread function to execute standardWorker.py
def startStandardWorker():
    execWorker = subprocess.Popen(["python3", "standardWorker.py", staticKeyID, staticKey])
    execWorker.wait()

def main():

    if (sender):

        for i in range(N_TEST):
            while True:
                try:
                    send_sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
                    send_sock.connect((target_host, port))
                    break
                except socket.error:
                    print("Connection Failed, Retrying..")
                    time.sleep(1)
                
            if (standardPSK):
                worker = Thread(target=startStandardWorker)
            else:
                worker = Thread(target=startKSworker)
            
            send_sock.recv(2048)
            worker.start()
            worker.join()
            send_sock.close()

    else:
        
        s = socket.socket(socket.AF_INET, socket.SOCK_STREAM) 
        s.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        s.bind((host, port))
        s.listen(5)

        for i in range(N_TEST):

            c, addr = s.accept()

            if (standardPSK):
                worker = Thread(target=startStandardWorker)
            else:
                worker = Thread(target=startKSworker)
            
            worker.start()
            time.sleep(1)

            msg = "ready\r\n" 
            c.send(msg.encode())
            
            worker.join()
            c.close()
            


if __name__ == '__main__':
    main()