import csv

server = True
logdir = './log/'

def scanFile(fname, csvWriter):

    with open(logdir + fname) as fp:
        iteration = 0
        times = []
        for i, line in enumerate(fp):
            if(line == '\n'):
                continue

    
            line = line.replace(" ", "")

            startLine, _, line = line.partition('[WALL]')
            w_time, _, line = line.partition('seconds')
            times.append(float(w_time))
            
            _, _, line = line.partition('[CPU]')
            cpu_time, _, _ = line.partition('seconds')
            times.append(float(cpu_time))

            if ('Execution' in startLine):
                iteration += 1
                times.insert(0, iteration)
                csvWriter.writerow(times)
                times.clear()


def main():

    if (server): 

        csvName = './server_setup.csv'

        with open(csvName, "w") as csvFp:
            csvWriter = csv.writer(csvFp, delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)
            csvWriter.writerow(['Iteration', 'Socket created and bound', '', 'Received handle', '', 'GET TOKEN', '', 'GET_KEY_WITH_ID', '', 'Stored key on file', '', 'Sent ACK, freed resources', '', 'Total time', ''])
            csvWriter.writerow(['', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time'])

            scanFile('server_setup.exectime', csvWriter)

        csvName = './test_server.csv'

        with open(csvName, "w") as csvFp:
            csvWriter = csv.writer(csvFp, delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)
            csvWriter.writerow(['Iteration', 'Retrieved key from file', '', 'Defined wolfssl options', '', 'Created Wolfssl object', '', 'TLS Handshake completed (first message)', '', 'Read and write completed', '', 'resources freed', '', 'Total time', ''])
            csvWriter.writerow(['', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time'])

            scanFile('test_server.exectime', csvWriter)


    else:

        csvName = './client_setup.csv'

        with open(csvName, "w") as csvFp:
            csvWriter = csv.writer(csvFp, delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)
            csvWriter.writerow(['Iteration', 'GET TOKEN', '', 'GET_KEY', '', 'Sent ACK', '', 'store key on file', '', 'Total time', ''])
            csvWriter.writerow(['', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time'])

            scanFile('client_setup.exectime', csvWriter)

        csvName = './test_client.csv'

        with open(csvName, "w") as csvFp:
            csvWriter = csv.writer(csvFp, delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)
            csvWriter.writerow(['Iteration', 'Retrieved key from file', '', 'Created Wolfssl structures', '', 'TLS Client Hello', '', 'TLS Handshake completed', '', 'Read and write completed', '', 'Resources freed', '',  'Total time', ''])
            csvWriter.writerow(['', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time', 'w_time', 'cpu_time'])

            scanFile('test_client.exectime', csvWriter)
                    

if __name__ == '__main__':
    main()